//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2020, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2024, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <trade/trade.mqh>

int GetTotalResultOne;
int GetTotalResultTwo;
int GetTotalResultThree;
int GetTotalResultFour;
int GetTotalResultFive;
int GetTotalResultSix;
int GetTotalResultSeven;
int GetTotalResultEight;
int GetTotalResultNine;
int GetTotalResultTen;
int GetTotalResultEleven;
int GetTotalResultTwelve;
int GetTotalResultThirteen;
int GetTotalResultFourteen;
int GetTotalResultFifteen;
int GetTotalResultSixteen;
int GetTotalResultSeventeen;
int GetTotalResultEighteen;
int GetTotalResultNineteen;
int GetTotalResultTwenty;
int GetTotalResultTwentyOne;
int GetTotalResultTwentyTwo;

int GetTotalResultOne1;
int GetTotalResultTwo1;
int GetTotalResultThree1;
int GetTotalResultFour1;
int GetTotalResultFive1;
int GetTotalResultSix1;
int GetTotalResultSeven1;
int GetTotalResultEight1;
int GetTotalResultNine1;
int GetTotalResultTen1;
int GetTotalResultEleven1;
int GetTotalResultTwelve1;
int GetTotalResultThirteen1;
int GetTotalResultFourteen1;
int GetTotalResultFifteen1;
int GetTotalResultSixteen1;
int GetTotalResultSeventeen1;
int GetTotalResultEighteen1;
int GetTotalResultNineteen1;
int GetTotalResultTwenty1;
int GetTotalResultTwentyOne1;
int GetTotalResultTwentyTwo1;

int MACD_handle;
int Stochastic_handle;
int ADX_handle;
int IchimokuCloud_handle;
int WPR;
int AO;
int Bull;
int Bear;
int IchimokuCloud_handle1;
int ADX_handle1;
int Stochastic_handle1;
int MACD_handle1;
int WPR1;
int AO1;
int Bull1;
int Bear1;
int AwesomeOS;
int AwesomeOS1;

CTrade trade;
input double Lots = 0.00001;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   int MACD_handle = iMACD(NULL,PERIOD_CURRENT,12,26,9,iClose(NULL, PERIOD_CURRENT, 1));
   int Stochastic_handle = iStochastic(NULL,PERIOD_CURRENT,14,3,3,MODE_SMA,STO_CLOSECLOSE);
   int ADX_handle = iADX(NULL,PERIOD_CURRENT,14);
   int IchimokuCloud_handle = iIchimoku(NULL,PERIOD_CURRENT,9,26, 52);
   int IchimokuCloud_handle1 = iIchimoku(NULL,PERIOD_M1, 9, 26, 52);
   int ADX_handle1 = iADX(NULL,PERIOD_M1, 14);
   int Stochastic_handle1 = iStochastic(NULL,PERIOD_M1,14,3,3,MODE_SMA,STO_CLOSECLOSE);
   int MACD_handle1 = iMACD(NULL,PERIOD_M1,12,26,9,iClose(NULL, PERIOD_M1, 1));
   int WPR = iWPR(NULL,PERIOD_CURRENT, 14);
   int WPR1 = iWPR(NULL,PERIOD_M1, 14);
   int AO = iAO(NULL, PERIOD_CURRENT);
   int AO1 = iAO(NULL,PERIOD_M1);
   int Bull = iBullsPower(NULL,PERIOD_CURRENT,13);
   int Bull1 = iBullsPower(NULL,PERIOD_M1,13);
   int Bear = iBearsPower(NULL,PERIOD_M1,13);
   int Bear1 = iBearsPower(NULL,PERIOD_M1,13);
   int AwesomeOS = iAO(NULL,PERIOD_CURRENT);
   int AwesomeOS1 = iAO(NULL,PERIOD_M1);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   double DailyOpen = iOpen(NULL,PERIOD_CURRENT,0);
   double DailyPreviousOpen = iOpen(NULL,PERIOD_CURRENT,1);

// This is the calculations for the moving averages for the 0 index (daily time frame)
   if(iMA(NULL,PERIOD_CURRENT,10,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultOne = 1;
      Print("MA1OneDay" + GetTotalResultOne);
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,10,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultOne = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,10,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultTwo = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,10,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultTwo = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,20,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultThree = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,20,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultThree = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,20,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultFour = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,20,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultFour = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,30,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultFive = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,30,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultFive = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,30,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultSix = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,30,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultSix = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,50,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultSeven = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,50,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultSeven = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,50,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultEight = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,50,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultEight = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,100,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultNine = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,100,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultNine = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,100,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultTen = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,100,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultTen = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,200,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultEleven = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,200,0,MODE_SMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultEleven = -1;
        }
   if(iMA(NULL,PERIOD_CURRENT,200,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) < iOpen(NULL,PERIOD_CURRENT,0))
     {
      GetTotalResultTwelve = 1;
     }
   else
      if(iMA(NULL,PERIOD_CURRENT,200,0,MODE_EMA,iClose(NULL,PERIOD_CURRENT,1)) > iOpen(NULL,PERIOD_CURRENT,0))
        {
         GetTotalResultTwelve = -1;
        }

   double RSIisRising;
   double RSIisFalling;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(iRSI(NULL,PERIOD_CURRENT,14,iClose(NULL,PERIOD_CURRENT,1)) > iRSI(NULL,PERIOD_CURRENT,14,iClose(NULL,PERIOD_CURRENT,2)))
     {
      RSIisRising == true;
     }
   if(iRSI(NULL,PERIOD_CURRENT,14,iClose(NULL,PERIOD_CURRENT,1)) < iRSI(NULL,PERIOD_CURRENT,14,iClose(NULL,PERIOD_CURRENT,2)))
     {
      RSIisFalling == true;
     }
   if((iRSI(NULL,PERIOD_CURRENT,14,iClose(NULL,PERIOD_CURRENT,1)) < 30)
      && RSIisRising == true)
     {
      GetTotalResultThirteen = 1;
     }
   else
      if((iRSI(NULL,PERIOD_CURRENT,14,iClose(NULL,PERIOD_CURRENT,1)) > 70)
         && RSIisFalling == true)
        {
         GetTotalResultThirteen = -1;
        }

   double CCIisRising;
   double CCIisFalling;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(iCCI(NULL,PERIOD_CURRENT,20,iClose(NULL,PERIOD_CURRENT,1)) > iCCI(NULL,PERIOD_CURRENT,20,iClose(NULL,PERIOD_CURRENT,2)))
     {
      CCIisRising == true;
     }
   if(iCCI(NULL,PERIOD_CURRENT,20,iClose(NULL,PERIOD_CURRENT,1)) < iCCI(NULL,PERIOD_CURRENT,20,iClose(NULL,PERIOD_CURRENT,2)))
     {
      CCIisFalling == true;
     }
   if((iCCI(NULL,PERIOD_CURRENT,20,iClose(NULL,PERIOD_CURRENT,1)) < -100)
      && CCIisRising == true)
     {
      GetTotalResultFourteen = 1;
     }
   else
      if((iCCI(NULL,PERIOD_CURRENT,20,iClose(NULL,PERIOD_CURRENT,1)) > 100)
         && CCIisFalling == true)
        {
         GetTotalResultFourteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(iMomentum(NULL,PERIOD_CURRENT,10,iClose(NULL,PERIOD_CURRENT,1)) > iMomentum(NULL,PERIOD_CURRENT,10,iClose(NULL,PERIOD_CURRENT,2)))
     {
      GetTotalResultFifteen = 1;
     }
   else
      if(iMomentum(NULL,PERIOD_CURRENT,10,iClose(NULL,PERIOD_CURRENT,1)) < iMomentum(NULL,PERIOD_CURRENT,10,iClose(NULL,PERIOD_CURRENT,2)))
        {
         GetTotalResultFifteen = -1;
        }

   double WilliamsRPercentageisRising;
   double WilliamsRPercentageisFalling;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double WPRArray[];
   if((CopyBuffer(WPR,0,1,5,WPRArray)) > (CopyBuffer(WPR,0,2,5,WPRArray)))
     {
      WilliamsRPercentageisRising == true;
     }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if((CopyBuffer(WPR,0,1,5,WPRArray)) < (CopyBuffer(WPR,0,2,5,WPRArray)))
     {
      WilliamsRPercentageisFalling == true;
     }
   if((iWPR(NULL,PERIOD_CURRENT,14) < -80)
      && WilliamsRPercentageisRising == true)
     {
      GetTotalResultSixteen = 1;
     }
   else
      if((iWPR(NULL,PERIOD_CURRENT,14) > -20)
         && WilliamsRPercentageisFalling == true)
        {
         GetTotalResultSixteen = -1;
        }

   double BearPowerisRising;
   double BullPowerisFalling;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double BearArray[];

   if(CopyBuffer(Bear,0,1,5,BearArray) > (CopyBuffer(Bear,0,2,5,BearArray)))
     {
      BearPowerisRising == true;
     }
   double BullArray[];

   if((CopyBuffer(Bull,0,1,5,BullArray)) < (CopyBuffer(Bull,0,2,5,BullArray)))
     {
      BullPowerisFalling == true;
     }
   if((iBearsPower(NULL,PERIOD_CURRENT,14) < 0)
      && BearPowerisRising == true && DailyOpen > DailyPreviousOpen)
     {
      GetTotalResultSeventeen = 1;
     }
   else
      if(((iBullsPower(NULL,PERIOD_CURRENT,14)) > 0)
         && BullPowerisFalling == true && DailyOpen < DailyPreviousOpen)
        {
         GetTotalResultSeventeen = -1;
        }

   double MACD_handle_Array[];
   if(CopyBuffer(MACD_handle, MAIN_LINE,0, 10, MACD_handle_Array) > CopyBuffer(MACD_handle, SIGNAL_LINE,0, 10, MACD_handle_Array))
     {
      GetTotalResultEighteen = 1;
     }
   else
      if(CopyBuffer(MACD_handle, MAIN_LINE,0, 10, MACD_handle_Array) < CopyBuffer(MACD_handle, SIGNAL_LINE,0, 10, MACD_handle_Array))
        {
         GetTotalResultEighteen = -1;
        }

   double Stochastic_Array[];
   double Stochastic_MainLineCurrent, Stochastic_SignalLineCurrent;
   double Stochastic_MainLinePrevious, Stochastic_SignalLinePrevious;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   Stochastic_MainLineCurrent = CopyBuffer(Stochastic_handle,MAIN_LINE,0,1,Stochastic_Array);
   Stochastic_SignalLineCurrent = CopyBuffer(Stochastic_handle,SIGNAL_LINE,0,1,Stochastic_Array);
   Stochastic_MainLinePrevious = CopyBuffer(Stochastic_handle,MAIN_LINE,1,1,Stochastic_Array);
   Stochastic_SignalLinePrevious = CopyBuffer(Stochastic_handle,SIGNAL_LINE,1,1,Stochastic_Array);

   if((Stochastic_MainLinePrevious < Stochastic_SignalLinePrevious) && (Stochastic_MainLineCurrent > Stochastic_SignalLineCurrent) && (Stochastic_MainLineCurrent < 20))
     {
      GetTotalResultNineteen = 1; // Buy: Main line crossed above signal line and is below 20
     }
   else
      if(Stochastic_MainLinePrevious > Stochastic_SignalLinePrevious && Stochastic_MainLineCurrent < Stochastic_SignalLineCurrent && Stochastic_MainLineCurrent > 80)
        {
         GetTotalResultNineteen = -1; // Sell: Main line crossed below signal line and is above 80
        }

   double ADX_Array[];
   double ADX_PlusDICurrent, ADX_MinusDICurrent;
   double ADX_PlusDIPrevious, ADX_MinusDIPrevious;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   ADX_PlusDICurrent = CopyBuffer(ADX_handle,PLUSDI_LINE,0,1,ADX_Array);
   ADX_MinusDICurrent = CopyBuffer(ADX_handle,MINUSDI_LINE,0,1,ADX_Array);
   ADX_PlusDIPrevious = CopyBuffer(ADX_handle,PLUSDI_LINE,1,1,ADX_Array);
   ADX_MinusDIPrevious = CopyBuffer(ADX_handle,MINUSDI_LINE,1,1,ADX_Array);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(iADX(NULL, PERIOD_CURRENT, 14) > 20 && ADX_PlusDIPrevious < ADX_MinusDIPrevious && ADX_PlusDICurrent > ADX_MinusDICurrent)
     {
      GetTotalResultTwenty = 1; // Buy: +DI crossed above -DI and ADX > 20
     }
   else
      if(iADX(NULL, PERIOD_CURRENT, 14) > 20 && ADX_PlusDIPrevious > ADX_MinusDIPrevious && ADX_PlusDICurrent < ADX_MinusDICurrent)
        {
         GetTotalResultTwenty = -1; // Sell: +DI crossed below -DI and ADX > 20
        }

   double Ichimoku_Array[];
   double DailyClose = iClose(NULL, PERIOD_CURRENT, 0); // Use Close Price for Ichimoku
   double Ichimoku_BaseLine, Ichimoku_ConversionLine, Ichimoku_SenkouSpanA, Ichimoku_SenkouSpanB;

   Ichimoku_BaseLine = CopyBuffer(IchimokuCloud_handle,KIJUNSEN_LINE,0,1,Ichimoku_Array);
   Ichimoku_ConversionLine = CopyBuffer(IchimokuCloud_handle,TENKANSEN_LINE,0,1,Ichimoku_Array);
   Ichimoku_SenkouSpanA = CopyBuffer(IchimokuCloud_handle, SENKOUSPANA_LINE,0,1,Ichimoku_Array);
   Ichimoku_SenkouSpanB = CopyBuffer(IchimokuCloud_handle, SENKOUSPANB_LINE,0,1,Ichimoku_Array);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(DailyClose > Ichimoku_BaseLine &&  //Price above Base Line
      DailyClose > Ichimoku_ConversionLine && //Price Above Conversion Line
      Ichimoku_ConversionLine > Ichimoku_BaseLine && //Conversion Line Above Base Line
      DailyClose > Ichimoku_SenkouSpanA && //Price Above Senkou Span A
      DailyClose > Ichimoku_SenkouSpanB && //Price Above Senkou Span B
      Ichimoku_SenkouSpanA > Ichimoku_SenkouSpanB)
     {
      GetTotalResultTwentyOne = 1; //Buy
     }
   else
      if(DailyClose < Ichimoku_BaseLine &&  //Price below Base Line
         DailyClose < Ichimoku_ConversionLine && //Price Below Conversion Line
         Ichimoku_ConversionLine < Ichimoku_BaseLine && //Conversion Line Below Base Line
         DailyClose < Ichimoku_SenkouSpanA && //Price Below Senkou Span A
         DailyClose < Ichimoku_SenkouSpanB && //Price Below Senkou Span B
         Ichimoku_SenkouSpanA < Ichimoku_SenkouSpanB)
        {
         GetTotalResultTwentyOne = -1; //Sell
        }
   double AwesomeOSArray[];
   if(((iAO(NULL,PERIOD_CURRENT) > 0) && (CopyBuffer(AwesomeOS,0,2,5,AwesomeOSArray)) < 0) && ((CopyBuffer(AwesomeOS,0,2,5,AwesomeOSArray)) < (CopyBuffer(AwesomeOS,0,2,5,AwesomeOSArray))))
     {
      GetTotalResultTwentyTwo = 1;
     }
   else
      if(((iAO(NULL,PERIOD_CURRENT) < 0) && (CopyBuffer(AwesomeOS,0,2,5,AwesomeOSArray))) > 0 && ((CopyBuffer(AwesomeOS,0,2,5,AwesomeOSArray)) > (CopyBuffer(AwesomeOS,0,3,5,AwesomeOSArray))))
        {
         GetTotalResultTwentyTwo = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double OneMinuteOpen = iOpen(NULL,PERIOD_M1,0);
   double OneMinutePreviousOpen = iOpen(NULL,PERIOD_M1,1);

// This is the calculations for the moving averages for the 1 index (OneMinute time frame)
   if(iMA(NULL,PERIOD_M1,10,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultOne1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,10,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultOne1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,10,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultTwo1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,10,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultTwo1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,20,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultThree1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,20,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultThree1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,20,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultFour1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,20,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultFour1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,30,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultFive1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,30,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultFive1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,30,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultSix1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,30,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultSix1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,50,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultSeven1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,50,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultSeven1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,50,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultEight1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,50,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultEight1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,100,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultNine1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,100,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultNine1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,100,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultTen1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,100,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultTen1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,200,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultEleven1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,200,0,MODE_SMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultEleven1 = -1;
        }
   if(iMA(NULL,PERIOD_M1,200,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) < iOpen(NULL,PERIOD_M1,0))
     {
      GetTotalResultTwelve1 = 1;
     }
   else
      if(iMA(NULL,PERIOD_M1,200,0,MODE_EMA,iClose(NULL,PERIOD_M1,1)) > iOpen(NULL,PERIOD_M1,0))
        {
         GetTotalResultTwelve1 = -1;
        }
   double RSIisRising1;
   double RSIisFalling1;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(iRSI(NULL,PERIOD_M1,14,iClose(NULL,PERIOD_M1,1)) > iRSI(NULL,PERIOD_M1,14,iClose(NULL,PERIOD_M1,2)))
     {
      RSIisRising1 == true;
     }
   if(iRSI(NULL,PERIOD_M1,14,iClose(NULL,PERIOD_M1,1)) < iRSI(NULL,PERIOD_M1,14,iClose(NULL,PERIOD_M1,2)))
     {
      RSIisFalling1 == true;
     }
   if((iRSI(NULL,PERIOD_M1,14,iClose(NULL,PERIOD_M1,1)) < 30)
      && RSIisRising1 == true)
     {
      GetTotalResultThirteen1 = 1;
     }
   else
      if((iRSI(NULL,PERIOD_M1,14,iClose(NULL,PERIOD_M1,1)) > 70)
         && RSIisFalling1 == true)
        {
         GetTotalResultThirteen1 = -1;
        }
   double CCIisRising1;
   double CCIisFalling1;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(iCCI(NULL,PERIOD_M1,20,iClose(NULL,PERIOD_M1,1)) > iCCI(NULL,PERIOD_M1,20,iClose(NULL,PERIOD_M1,2)))
     {
      CCIisRising1 == true;
     }
   if(iCCI(NULL,PERIOD_M1,20,iClose(NULL,PERIOD_M1,1)) < iCCI(NULL,PERIOD_M1,20,iClose(NULL,PERIOD_M1,2)))
     {
      CCIisFalling1 == true;
     }

   if((iCCI(NULL,PERIOD_M1,20,iClose(NULL,PERIOD_M1,1)) < -100)
      && CCIisRising1 == true)
     {
      GetTotalResultFourteen1 = 1;
     }
   else
      if((iCCI(NULL,PERIOD_M1,20,iClose(NULL,PERIOD_M1,1)) > 100)
         && CCIisFalling1 == true)
        {
         GetTotalResultFourteen1 = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(iMomentum(NULL,PERIOD_M1,10,iClose(NULL,PERIOD_M1,1)) > iMomentum(NULL,PERIOD_M1,10,iClose(NULL,PERIOD_M1,2)))
     {
      GetTotalResultFifteen1 = 1;
     }
   else
      if(iMomentum(NULL,PERIOD_M1,10,iClose(NULL,PERIOD_M1,1)) < iMomentum(NULL,PERIOD_M1,10,iClose(NULL,PERIOD_M1,2)))
        {
         GetTotalResultFifteen1 = -1;
        }

   double WilliamsRPercentageisRising1;
   double WilliamsRPercentageisFalling1;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double WPRArray1[];

   if((CopyBuffer(WPR1,0,1,5,WPRArray1)) > (CopyBuffer(WPR1,0,2,5,WPRArray1)))
     {
      WilliamsRPercentageisRising1 == true;
     }
   if((CopyBuffer(WPR1,0,1,5,WPRArray1)) < (CopyBuffer(WPR1,0,2,5,WPRArray1)))
     {
      WilliamsRPercentageisFalling1 == true;
     }
   if((iWPR(NULL,PERIOD_M1,14) < -80)
      && WilliamsRPercentageisRising1 == true)
     {
      GetTotalResultSixteen1 = 1;
     }
   else
      if((iWPR(NULL,PERIOD_M1,14) > -20)
         && WilliamsRPercentageisFalling1 == true)
        {
         GetTotalResultSixteen1 = -1;
        }

   double BearPowerisRising1;
   double BullPowerisFalling1;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double BearArray1[];

   if(CopyBuffer(Bear1,0,1,5,BearArray1) > (CopyBuffer(Bear1,0,2,5,BearArray1)))
     {
      BearPowerisRising1 == true;
     }
   double BullArray1[];

   if((CopyBuffer(Bull1,0,1,5,BullArray1)) < (CopyBuffer(Bull1,0,2,5,BullArray1)))
     {
      BullPowerisFalling1 == true;
     }
   if((iBearsPower(NULL,PERIOD_M1,13) < 0)
      && BearPowerisRising1 == true && OneMinuteOpen > OneMinutePreviousOpen)
     {
      GetTotalResultSeventeen1 = 1;
     }
   else
      if(((iBullsPower(NULL,PERIOD_M1,13)) > 0)
         && BullPowerisFalling1 == true && OneMinuteOpen < OneMinutePreviousOpen)
        {
         GetTotalResultSeventeen1 = -1;
        }

   double MACD_handle1_Array[];
   if(CopyBuffer(MACD_handle1, MAIN_LINE,0, 10, MACD_handle1_Array) > CopyBuffer(MACD_handle1, SIGNAL_LINE,0, 10, MACD_handle1_Array))
     {
      GetTotalResultEighteen1 = 1;
     }
   else
      if(CopyBuffer(MACD_handle1, MAIN_LINE,0, 10, MACD_handle1_Array) < CopyBuffer(MACD_handle1, SIGNAL_LINE,0, 10, MACD_handle1_Array))
        {
         GetTotalResultEighteen1 = -1;
        }

   double Stochastic1_Array[];
   double Stochastic_MainLineCurrent1, Stochastic_SignalLineCurrent1;
   double Stochastic_MainLinePrevious1, Stochastic_SignalLinePrevious1;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   Stochastic_MainLineCurrent1 = CopyBuffer(Stochastic_handle1,MAIN_LINE,0,0,Stochastic1_Array);
   Stochastic_SignalLineCurrent1 = CopyBuffer(Stochastic_handle1,SIGNAL_LINE,0,0,Stochastic1_Array);
   Stochastic_MainLinePrevious1 = CopyBuffer(Stochastic_handle1,MAIN_LINE,1,0,Stochastic1_Array);
   Stochastic_SignalLinePrevious1 = CopyBuffer(Stochastic_handle1,SIGNAL_LINE,1,0,Stochastic1_Array);

   if(Stochastic_MainLinePrevious1 < Stochastic_SignalLinePrevious1 && Stochastic_MainLineCurrent1 > Stochastic_SignalLineCurrent1 && Stochastic_MainLineCurrent1 < 20)
     {
      GetTotalResultNineteen1 = 1; // Buy: Main line crossed above signal line and is below 20
     }
   else
      if(Stochastic_MainLinePrevious1 > Stochastic_SignalLinePrevious1 && Stochastic_MainLineCurrent1 < Stochastic_SignalLineCurrent1 && Stochastic_MainLineCurrent1 > 80)
        {
         GetTotalResultNineteen1 = -1; // Sell: Main line crossed below signal line and is above 80
        }

   double ADX1_Array[];
   double ADX_PlusDICurrent1, ADX_MinusDICurrent1;
   double ADX_PlusDIPrevious1, ADX_MinusDIPrevious1;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   ADX_PlusDICurrent1 = CopyBuffer(ADX_handle1,PLUSDI_LINE,0,1,ADX1_Array);
   ADX_MinusDICurrent1 = CopyBuffer(ADX_handle1,MINUSDI_LINE,0,1,ADX1_Array);
   ADX_PlusDIPrevious1 = CopyBuffer(ADX_handle1,PLUSDI_LINE,1,1,ADX1_Array);
   ADX_MinusDIPrevious1 = CopyBuffer(ADX_handle1,MINUSDI_LINE,1,1,ADX1_Array);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(iADX(NULL, PERIOD_M1, 14) > 20 && ADX_PlusDIPrevious1 < ADX_MinusDIPrevious1 && ADX_PlusDICurrent1 > ADX_MinusDICurrent1)
     {
      GetTotalResultTwenty1 = 1; // Buy: +DI crossed above -DI and ADX > 20
     }
   else
      if(iADX(NULL, PERIOD_M1, 14) > 20 && ADX_PlusDIPrevious1 > ADX_MinusDIPrevious1 && ADX_PlusDICurrent1 < ADX_MinusDICurrent1)
        {
         GetTotalResultTwenty1 = -1; // Sell: +DI crossed below -DI and ADX > 20
        }

   double Ichimoku_Array1[];
   double OneMinuteClose = iClose(NULL, PERIOD_M1, 0); // Use Close Price for Ichimoku
   double Ichimoku_BaseLine1, Ichimoku_ConversionLine1, Ichimoku_SenkouSpanA1, Ichimoku_SenkouSpanB1;

   Ichimoku_BaseLine1 = CopyBuffer(IchimokuCloud_handle1,KIJUNSEN_LINE,1,0,Ichimoku_Array1);
   Ichimoku_ConversionLine1 = CopyBuffer(IchimokuCloud_handle1,TENKANSEN_LINE,0,0,Ichimoku_Array1);
   Ichimoku_SenkouSpanA1 = CopyBuffer(IchimokuCloud_handle1,SENKOUSPANA_LINE,1,0,Ichimoku_Array1);
   Ichimoku_SenkouSpanB1 = CopyBuffer(IchimokuCloud_handle1,SENKOUSPANB_LINE,1,0,Ichimoku_Array1);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(OneMinuteClose > Ichimoku_BaseLine1 &&  //Price above Base Line
      OneMinuteClose > Ichimoku_ConversionLine1 && //Price Above Conversion Line
      Ichimoku_ConversionLine1 > Ichimoku_BaseLine1 && //Conversion Line Above Base Line
      OneMinuteClose > Ichimoku_SenkouSpanA1 && //Price Above Senkou Span A
      OneMinuteClose > Ichimoku_SenkouSpanB1 && //Price Above Senkou Span B
      Ichimoku_SenkouSpanA1 > Ichimoku_SenkouSpanB1)
     {
      GetTotalResultTwentyOne1 = 1; //Buy
     }
   else
      if(OneMinuteClose < Ichimoku_BaseLine1 &&  //Price below Base Line
         OneMinuteClose < Ichimoku_ConversionLine1 && //Price Below Conversion Line
         Ichimoku_ConversionLine1 < Ichimoku_BaseLine1 && //Conversion Line Below Base Line
         OneMinuteClose < Ichimoku_SenkouSpanA1 && //Price Below Senkou Span A
         OneMinuteClose < Ichimoku_SenkouSpanB1 && //Price Below Senkou Span B
         Ichimoku_SenkouSpanA1 < Ichimoku_SenkouSpanB1)
        {
         GetTotalResultTwentyOne1 = -1; //Sell
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double AwesomeOSArray1[];
   if(((iAO(NULL,PERIOD_M1) > 0) && (CopyBuffer(AwesomeOS1,0,2,5,AwesomeOSArray1)) < 0) && ((CopyBuffer(AwesomeOS1,0,2,5,AwesomeOSArray1)) < (CopyBuffer(AwesomeOS1,0,2,5,AwesomeOSArray1))))
     {
      GetTotalResultTwentyTwo1 = 1;
     }
   else
      if(((iAO(NULL,PERIOD_M1) < 0) && (CopyBuffer(AwesomeOS1,0,2,5,AwesomeOSArray1))) > 0 && ((CopyBuffer(AwesomeOS1,0,2,5,AwesomeOSArray1)) > (CopyBuffer(AwesomeOS1,0,3,5,AwesomeOSArray1))))
        {
         GetTotalResultTwentyTwo1 = -1;
        }

   double MovingAverageOneDayPreCalculation = GetTotalResultOne + GetTotalResultTwo + GetTotalResultThree + GetTotalResultFour + GetTotalResultFive + GetTotalResultSix + GetTotalResultSeven + GetTotalResultEight + GetTotalResultNine + GetTotalResultTen + GetTotalResultEleven + GetTotalResultTwelve;
   double MovingAverageOneDay = MovingAverageOneDayPreCalculation/12;
   Print("MA One Day" + MovingAverageOneDay);

   double OSOneDayPreCalculation = GetTotalResultThirteen + GetTotalResultFourteen + GetTotalResultFifteen + GetTotalResultSixteen + GetTotalResultSeventeen + GetTotalResultEighteen + GetTotalResultNineteen + GetTotalResultTwenty + GetTotalResultTwentyOne;
   double OSOneDay = OSOneDayPreCalculation/9;
   Print("OS One Day" + OSOneDay);

   double MovingAverageOneMinutePreCalculation = GetTotalResultOne1 + GetTotalResultTwo1 + GetTotalResultThree1 + GetTotalResultFour1 + GetTotalResultFive1 + GetTotalResultSix1 + GetTotalResultSeven1 + GetTotalResultEight1 + GetTotalResultNine1 + GetTotalResultTen1 + GetTotalResultEleven1 + GetTotalResultTwelve1;
   double MovingAverageOneMinute = MovingAverageOneMinutePreCalculation/12;
   Print("MA One Minute" + MovingAverageOneMinute);

   double OSOneMinutePreCalculation = GetTotalResultThirteen1 + GetTotalResultFourteen1 + GetTotalResultFifteen1 + GetTotalResultSixteen1 + GetTotalResultSeventeen1 + GetTotalResultEighteen1 + GetTotalResultNineteen1 + GetTotalResultTwenty1 + GetTotalResultTwentyOne1;
   double OSOneMinute = OSOneMinutePreCalculation/9;
   Print("OS One Minute" + OSOneMinute);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   bool UpMarket = (MovingAverageOneDay == 1 && MovingAverageOneMinute == -1 && OSOneDay > 0 && OSOneMinute == 0);
   bool DownMarket = (MovingAverageOneDay == -1 && MovingAverageOneMinute == 1 && OSOneDay < 0 && OSOneMinute == 0);

   double UnrealziedPnL = ACCOUNT_PROFIT;
   double AccountEquity = ACCOUNT_EQUITY;
   double StopLossCalculation = (UnrealziedPnL / AccountEquity)*100;
   double StopLoss = StopLossCalculation <= -5;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double BuyPrice = SymbolInfoDouble(NULL,SYMBOL_ASK);
   double SellPrice = SymbolInfoDouble(NULL,SYMBOL_BID);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
// Check overall conditions for placing a trade
   if(BuyPrice < DailyOpen && UpMarket == true)
     {
      double EnterLong = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
      EnterLong = NormalizeDouble(EnterLong,_Digits);
      trade.Buy(Lots,NULL,EnterLong,StopLoss,"Enter Long");
     }

// Check conditions to enter a short position
   if(SellPrice > DailyOpen && DownMarket == true)
     {
      double EnterShort = SymbolInfoDouble(_Symbol,SYMBOL_BID);
      EnterShort = NormalizeDouble(EnterShort,_Digits);
      trade.Sell(Lots,NULL,EnterShort,StopLoss,"Enter Short");
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
